# Cmput 455 sample code
# Test cases for solving TicTacToe by a series 
# of depth-limited searches
# Written by Martin Mueller

from alphabeta_depth_limited import callAlphabetaDL
from tic_tac_toe_integer_eval import TicTacToe
import time

def timeSearchDL(name, search, root, depth):
    start = time.process_time()
    result = search(root, depth)
    timeUsed = time.process_time() - start
    print(name, "Depth", depth, "Result", result,
          "Time used: ", timeUsed)

# call depth-limited search for all depths
# Note: this code does not distinguish 
# between a proven draw and "no win found"
# both are evaluated as 0
def iterativeDeepening(t, maxDepth):
    t.print()
    for depth in range(12):
        timeSearchDL("Depth-limited AlphaBeta", 
                     callAlphabetaDL, t, depth)

t = TicTacToe()
iterativeDeepening(t, 12)

t.play(0)
t.play(3) # Mistake, now X can win
iterativeDeepening(t, 12)
